
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>python的遍历模式 / 憋错料</title>

    <meta name="description" content="python的遍历模式 python的遍历在程序中很重要,详细了解一下遍历模式,可以应用于任务分发,数据的读写中. python的 递归遍历目录: import os def getAllDirRE(path, sp = &quot;&quot;): #得到当前目录下所有的文件 filesList = os.listdir(path) #处理每一个文件 sp += &quot; &quot; for fileName in filesList: #判断是否是路径(用绝对路径) fileAbsPath = os.path ...">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">python的遍历模式</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p>python的遍历在程序中很重要，详细了解一下遍历模式，可以应用于任务分发，数据的读写中。</p>
<p>python的 递归遍历目录：</p>
<pre>import os

def getAllDirRE(path, sp = ""):    #得到当前目录下所有的文件    filesList = os.listdir(path)    #处理每一个文件    sp += "   "    for fileName in filesList:        #判断是否是路径（用绝对路径）        fileAbsPath = os.path.join(path, fileName)        if os.path.isdir(fileAbsPath):            print(sp + "目录：", fileName)            #递归调用            getAllDirRE(fileAbsPath, sp)        else:            print(sp + "普通文件：", fileName)

getAllDirRE(r"C:\Users\xlg\Desktop\Python-1704\day09\temp\dir")

python栈模拟递归遍历目录（深度遍历）：</pre>
<pre>import os

def getAllDirDE(path):    stack = []    stack.append(path)

    #处理栈，当栈为空的时候结束循环    while len(stack) != 0:        #从栈里取出数据        #[]        dirPath = stack.pop()        #print(dirPath)        #目录下所有文件        filesList = os.listdir(dirPath)        #print(filesList)        #处理每一个文件，如果是普通文件则打印出来，如果是目录则将该目录的地址压栈        for fileName in filesList:            fileAbsPath = os.path.join(dirPath, fileName)            if os.path.isdir(fileAbsPath):                #是目录就压栈                print("目录：" + fileName)                stack.append(fileAbsPath)                #["B", "E", "F"]            else:                #打印普通文件                print("普通：" + fileName)

getAllDirDE(r"C:\Users\xlg\Desktop\Python-1704\day09\temp\dir")

python的广度遍历目录（队列）：</pre>
<pre>import osimport collections

def getAllDirQU(path):    queue = collections.deque()    #进队    queue.append(path)    while len(queue) != 0:        #出队数据        dirPath = queue.popleft()        #找出所有的文件        filesList = os.listdir(dirPath)

        for fileName in filesList:            #绝对路径            fileAbsPath = os.path.join(dirPath, fileName)            #判断是否是目录，是目录就进队，不是就打印            if os.path.isdir(fileAbsPath):                print("目录：" + fileName)                queue.append(fileAbsPath)            else:                print("普通文件：" + fileName)

getAllDirQU(r"C:\Users\xlg\Desktop\Python-1704\day09\temp\dir")</pre>
<pre>&nbsp;</pre>
<pre>&nbsp;</pre>

<p>原文地址：https://www.cnblogs.com/mumu1/p/12708277.html</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-26 03:34:30 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/pat/" title="pat">pat</a>, <a href="https://www.biecuoliao.com/tag/%e6%89%93%e5%8d%b0/" title="打印">打印</a>, <a href="https://www.biecuoliao.com/tag/ack/" title="ack">ack</a>, <a href="https://www.biecuoliao.com/tag/else/" title="else">else</a>, <a href="https://www.biecuoliao.com/tag/list/" title="list">list</a>, <a href="https://www.biecuoliao.com/tag/user/" title="user">user</a>, <a href="https://www.biecuoliao.com/tag/%e7%bb%9d%e5%af%b9%e8%b7%af%e5%be%84/" title="绝对路径">绝对路径</a>, <a href="https://www.biecuoliao.com/tag/%e4%bb%bb%e5%8a%a1%e5%88%86%e5%8f%91/" title="任务分发">任务分发</a>, <a href="https://www.biecuoliao.com/tag/%e6%b7%b1%e5%ba%a6%e9%81%8d%e5%8e%86/" title="深度遍历">深度遍历</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>python的遍历模式的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVYxGj4.html" rel="bookmark">Python文件遍历二种方法</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				分享下有关Python文件遍历的两种方法,使用的OS模块的os.walk和os.listdir实现. 关于Python的文件遍历,大概有两种方法,一种是较为便利的os.walk(),还有一种是利用os.listdir()递归遍历.方法一:利用os.walkos.walk可以自顶向下或者自底向上遍历整个文件树,然后返回一个含有3个元素的tuple,(dirpath, dirnames, filenames).注意,os.walk()会返回一个generater,所以调用的时候一定要放到for循环中			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0e7lV54.html" rel="bookmark">Python递归遍历目录下所有文件</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				#自定义函数: import ospath=&quot;D:\\Temp_del\\a&quot; def gci (path): parents = os.listdir(path) for parent in parents: child = os.path.join(path,parent) #print(child) if os.path.isdir(child): gci(child) # print(child) else: print(child) gci(path) #使用os.walk方			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZaDXg0.html" rel="bookmark">python list遍历时删除元素</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				python list遍历时候删除还真需要注意下,今天帮同学处理数据,竟然傻逼了. 需求: 除了第一列,给每列加一个序号如:&quot;1:0&quot;,&quot;2:0&quot;,&quot;3:20100307&quot;,然后删除冒号后为0的数据. 推荐做法: arrays = [ ['5001', '0', '0', '20100307', '20150109', '2', '3', '75', '0', '0', '114', '13', '2', '0', '0'], ['10001',			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Mm8xA14.html" rel="bookmark">python list遍历</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				python list遍历 是对列表进行的经常性的操作.比如我们需要遍历一个列表: info = ['a','b','c','d','ee','fff'] for m in range(len(info)): print info[m] 有些朋友可能喜欢这样操作,但是其实没必要计算列表的长度了.我们可以直接用列表的迭代来处理,比如: for m in info: print m			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0krRydM.html" rel="bookmark">python 正则表达式 贪婪模式的简介和匹配时的几种模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				看到一篇文章,关于python正则的,http://www.cnblogs.com/huxi/archive/2010/07/04/1771073.html 贪婪模式与非贪婪模式: 正则表达式通常用于在文本中查找匹配的字符串.Python里数量词默认是贪婪的(在少数语言里也可能是默认非贪婪),总是尝试匹配尽可能多的字符:非贪婪的则相反,总是尝试匹配尽可能少的字符.例如:正则表达式&quot;ab*&quot;如果用于查找&quot;abbbc&quot;,将找到&quot;abbb&quot;.而如果使用			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4N6lDG4.html" rel="bookmark">浅谈Python设计模式 - 外观模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				声明:本系列文章主要参考&lt;精通Python设计模式&gt;一书,并且参考一些资料,结合自己的一些看法来总结而来. 外观模式 外观模式的核心在于将复杂的内部实现包装起来,只向外界提供简单的调用接口.类似现实世界中的电脑,开机按钮可以说就是一个简单的调用接口,帮用户屏蔽了复杂的内部电路. 外观设计模式 -- 有助于隐藏系统的内部复杂性,并且通过一个简化的接口向客户端暴露必要的部分.本质上,外观是在已有复杂系统之上实现的一个抽象层. 本来想引用书中的例子,但是其整个代码被复杂化,不好理解.然后在网上看到一			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MVnKq2M.html" rel="bookmark">python&plus;selenium遍历某一个标签中的内容</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.python+selenium遍历某一个标签中的内容 举个例子:我要获取列表标签&lt;li&gt;&lt;/li&gt;的内容 根据python+selenium定位到列表整体,使用for循环获取列表文本:可用于校验列表是否存在你需要的文本内容 1.获取内容不包含嵌套层列表 给出代码: from selenium import webdriver import time d = webdriver.Chrome() d.maximize_window() # 窗口最大化###登录某网站 d.get(			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3OwNx93.html" rel="bookmark">用Python实现工厂模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				class CarFactory: '''用Python实现工厂模式''' def creatCar(self, car_name): if car_name == 'Benz': car = Benz() elif car_name == 'BMW': car = BMW() else: car = BYD() return car class Benz: def __init__(self): print('奔驰产生了') class BMW: def __init__(self): pri			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/Q0xpvr0.html" rel="bookmark">python 正则贪婪模式和非贪婪模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				贪婪模式:在表达式匹配成功的前提下,总是尽可能多的匹配字符飞天蓝模式:在表达式匹配成功的前提下,总是尽量少的匹配字符 1 # !/usr/bin/env python 2 # -*- coding:utf-8 -*- 3 import re 4 5 def test(): 6 string = &quot;abc123456789sdsddskcas&quot; 7 print &quot;a(.*)c贪婪模式匹配结果:&quot; 8 print re.findall(r&quot;a(.*)c&quo			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/v0k7l0d.html" rel="bookmark" class="title">【自动化&lowbar;&lowbar;持续集成】&lowbar;&lowbar;&lowbar;java&lowbar;&lowbar;&lowbar;文本文件&lowbar;&lowbar;字节流</a>
					<div>
						一.代码如下 package www.wujianbotwo; import java.io.File; import java.io.FileInputStream; import java.io. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/VMG2764.html" rel="bookmark" class="title">3、Linux内核模块学习</a>
					<div>
						一.内核模块的学习   内核的整体框架是非常的大,包含的组件也是非常多,如何将需要的组件包含在内核中呢?选择一,就是将所有的组件全部编译进内核,虽然需要的组件都可以使用,但是内核过分庞大,势必带来效率 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4NJEj64.html" rel="bookmark" class="title">bzoj1180&colon; &lbrack;CROATIAN2009&rsqb;OTOCI</a>
					<div>
						Description 给出n个结点以及每个点初始时对应的权值wi.起始时点与点之间没有连边.有3类操作: 1.bridge A B:询问结点A与结点B是否连通.如果是则输出&quot;no&quot ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lGvZEM.html" rel="bookmark" class="title">AtCoder 2316 思维题</a>
					<div>
						题目链接:https://vjudge.net/problem/AtCoder-2316 题意:给你n个人的位置,每个人能往左跳一格或两格到无人的位置,跳到0位置,这个人消失.n个人消失组成一个排列, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MP8jxPM.html" rel="bookmark" class="title">【repost】JavaScript运动框架之速度时间版本</a>
					<div>
						一.JavaScript运动框架之速度版 1.1 运动框架的实现思路 运动,其实就是在一段时间内改变 left . right . width . height . opactiy 的值,到达目的地之 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YX57qM.html" rel="bookmark" class="title">解决ubuntu的wifi连接不稳定</a>
					<div>
						我笔记本用ubuntu的时候连wifi总是掉线重连,解决的途径是要去看/etc/ppp/下的option ppp就是点对点协议,所有与ppp配置相关的文件都放在这个目录下 那就sudo vim /et ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ODpG74.html" rel="bookmark" class="title">ReactiveCocoa 编程框架学习（一）</a>
					<div>
						ReactiveCocoa ReactiveCocoa是函数响应式编程(FRP)框架. 1.函数式编程:把操作尽量写成一系列嵌套的函数或者方法调用. 2.响应式编程:不需要考虑调用顺序,只需要知道考虑 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j1lDZM.html" rel="bookmark" class="title">sequelize中的association使用讲解，nodejs</a>
					<div>
						注:本文使用sequelize 1.7.0.所举例子均已通过测试,可以放心使用. 使用sequelize能够较为方便的按照MVC模式组织nodejs程序后端架构.这篇文章,就笔者认为,其中较为有用且稍 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPw5Lm4.html" rel="bookmark" class="title">基于Spark构建开放式的云计算平台第一阶段课程</a>
					<div>
						在2014年6月30日到7月2日举行的Spark Summit是整个云计算大数据领域的Big Event,在会议上DataBricks公司提出了构建开放的Cloud平台,而且宣布该平台完全基于Spar ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MWVVVr4.html" rel="bookmark" class="title">dom4J使用笔记</a>
					<div>
						使用dom4j是目前最常用的解析XML的方法,dom4j解析集DOM和SAX技术优点于一身,要使用dom4j 还是先要导入jar: dom4j-1.6.1.jar (dom4j最主要的jar包,可以独 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49L7z13.html" rel="bookmark" class="title">作业，6</a>
					<div>
						1.有一个四位正整数,组成这个四位数的四个数字各不相同,如果把它们的首尾互换,第二位与第三位互换,组成一个新的四位数.原四位数为新四位数的4倍,请找出一个这样的四位数. #include&lt;std ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vzw5g3.html" rel="bookmark" class="title">MFC工程资源相对路径</a>
					<div>
						Project-&gt;Properties-&gt;Configuration Properties-&gt;Debuging-&gt;Working Directory改为$(ProjectDir ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nRRgx0.html" rel="bookmark" class="title">centos6&period;5上网络不通解决方法</a>
					<div>
						vi /etc/sysconfig/network-scripts/ifcfg-eth0 配置内容参考如下(根据自己实际情况修改关键注意#号注释部分) 1 2 3 4 5 6 7 DEVICE=eth ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0ez2NJ3.html" rel="bookmark" class="title">可变数组继承不可变数组，添、删、改、查、替换</a>
					<div>
						#define NSLog(FORMAT, ...) fprintf(stderr,&quot;%s\n&quot;,[[NSString stringWithFormat:FORMAT, ##__V ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41wdxq0.html" rel="bookmark" class="title">css扩展技术</a>
					<div>
						在原来的基础上扩展了编程语言的特性. less(早期):定义变量[email protected]&amp;-当前对象,如:.class1{ .whb(100px,100px,red); &amp;: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyB79A0.html" rel="bookmark" class="title">Linux命令之find（二）</a>
					<div>
						上篇文章已经介绍了expressions的的test,它是find命令最核心的东西,现在介绍expressions的options和actions. (一)options -d,-depth:二者作用 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVva5zM.html" rel="bookmark" class="title">AT&amp;amp&semi;T学习笔记汇编之内核</a>
					<div>
						内核组成: 内存管理 设备管理 文件系统管理 进程管理 内存管理: 虚拟内存 交换空间 页面(块) cat    /proc/meminfo ipcs    -m 设备管理: 硬件管理  内核模块(k ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l1KdE3.html" rel="bookmark" class="title">MS08&lowbar;067漏洞测试&mdash;&mdash;20145301</a>
					<div>
						MS08_067漏洞测试 实验步骤 search MS08_067查看相关信息 show payloads命令查找需要的攻击载荷 选择generic/shell_reverse_tcp来获取漏洞主机的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLroWO3.html" rel="bookmark" class="title">转 http&colon;&sol;&sol;blog&period;chinaunix&period;net&sol;uid-20357359-id-1963508&period;html</a>
					<div>
						使用Python访问Windows的注册表 在Python的标准库中,_winreg.pyd可以操作Windows的注册表,另外第三方的win32库封装了大量的Windows API,使用起来也很方便 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35N9En4.html" rel="bookmark" class="title">51 nod 1681 公共祖先 &lpar;主席树&plus;dfs序&rpar;</a>
					<div>
						1681 公共祖先 基准时间限制:1 秒 空间限制:131072 KB 分值: 80 难度:5级算法题 有一个庞大的家族,共n人.已知这n个人的祖辈关系正好形成树形结构(即父亲向儿子连边). 在另一个 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.027 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
